//------------------------------------------------------------------
// Stochastic Momentum Index developed by William Blau
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  LimeGreen
#property indicator_color4  Orange
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  2
#property indicator_width4  2
#property strict
//
//
//
//
//


extern int    SMIPeriod1      = 13;    // Period 1
extern int    SMIPeriod2      = 25;    // Period 2
extern int    SMIPeriod3      =  2;    // Period 3
extern int    SignalPeriod    =  5;    // Signal period
extern bool   CandlesOnSlope  = false; // Color change on slope change?
extern bool   alertsOn        = true;  // Turn alerts on ?
extern bool   alertsOnCurrent = false; // Alerts on current bar?
extern bool   alertsMessage   = true;  // Display alerts message?
extern bool   alertsSound     = false; // Play alerts sound?
extern bool   alertsNotify    = false; // Send notification?
extern bool   alertsEmail     = false; // Send email?
extern string soundFile       = "alert2.wav"; // Sound file

//
//
//
//
//

double smihu[];
double smihd[];
double smihbu[];
double smihbd[];
double SMIBuffer[];
double SignalBuffer[];
double colors[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,smihu);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,smihd);  SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,smihbu); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,smihbd); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,SMIBuffer);
   SetIndexBuffer(5,SignalBuffer);
   SetIndexBuffer(6,colors);
   IndicatorShortName("SMI ("+(string)SMIPeriod1+","+(string)SMIPeriod2+","+(string)SMIPeriod3+","+(string)SignalPeriod+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][4];
#define _ema00 0
#define _ema01 1
#define _ema10 2
#define _ema11 3

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //
   
      double alfaS = 2.0 / (1.0 + SignalPeriod);
      double alfa1 = 2.0 / (1.0 + SMIPeriod2);
      double alfa2 = 2.0 / (1.0 + SMIPeriod3);

      for (i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         double highest = High[iHighest(NULL,0,MODE_HIGH,SMIPeriod1,i)];
         double lowest  = Low [iLowest (NULL,0,MODE_LOW ,SMIPeriod1,i)];
         double sm      = Close[i]-(highest+lowest)*0.5;
         double hl      =           highest-lowest;

            work[r][_ema00] = (i<Bars-1) ? work[r-1][_ema00]+alfa1*(sm             -work[r-1][_ema00]) : sm;
            work[r][_ema01] = (i<Bars-1) ? work[r-1][_ema01]+alfa2*(work[r][_ema00]-work[r-1][_ema01]) : sm;
            work[r][_ema10] = (i<Bars-1) ? work[r-1][_ema10]+alfa1*(hl             -work[r-1][_ema10]) : hl;
            work[r][_ema11] = (i<Bars-1) ? work[r-1][_ema11]+alfa2*(work[r][_ema10]-work[r-1][_ema11]) : hl;
            if (work[r][_ema11] != 0)
                  SMIBuffer[i] = 100.00*(work[r][_ema01]/(0.5*work[r][_ema11]));
            else  SMIBuffer[i] = 0;
            SignalBuffer[i] = (i<Bars-1) ? SignalBuffer[i+1] + alfaS*(SMIBuffer[i]-SignalBuffer[i+1]) : SMIBuffer[i];
            
            //
            //
            //
            //
            //
            
            smihu[i]  = EMPTY_VALUE;
            smihd[i]  = EMPTY_VALUE;
            smihbu[i] = EMPTY_VALUE;
            smihbd[i] = EMPTY_VALUE;
            colors[i] = (i<Bars-1) ? colors[i+1] : 0;
               if (CandlesOnSlope)
               {
                  if ((i<Bars-1) && SMIBuffer[i]>SMIBuffer[i+1]) colors[i]= 1;
                  if ((i<Bars-1) && SMIBuffer[i]<SMIBuffer[i+1]) colors[i]=-1;
               }
               else
               {
                  if (SMIBuffer[i]>SignalBuffer[i]) colors[i]= 1;
                  if (SMIBuffer[i]<SignalBuffer[i]) colors[i]=-1;
               }
               
               if (colors[i] == 1)
               {
                 smihu[i]  = High[i]; 
                 smihd[i]  = Low[i];
                 smihbu[i] = MathMax(Open[i],Close[i]);
                 smihbd[i] = MathMin(Open[i],Close[i]);
               }               
               if (colors[i] == -1)
               {
                 smihu[i]  = Low[i];
                 smihd[i]  = High[i];
                 smihbu[i] = MathMin(Open[i],Close[i]);
                 smihbd[i] = MathMax(Open[i],Close[i]);
               }               
               
      }
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
        int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
        if (colors[whichBar] != colors[whichBar+1])
        {
           if (colors[whichBar] == 1) doAlert(whichBar,"up");
           if (colors[whichBar] ==-1) doAlert(whichBar,"down");
        }         
      }
return(0);
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Blau - smi candles ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Blau - smi candles "),message);
          if (alertsSound)   PlaySound(soundFile);
   }
}



